=== debian/changelog ===
ros-galactic-ruckig (0.6.3-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Lars Berscheid <lars@ruckig.com>  Sat, 22 Jan 2022 01:57:08 -0000
