=== debian/control ===
Source: ros-galactic-ruckig
Section: misc
Priority: optional
Maintainer: Lars Berscheid <lars@ruckig.com>
Build-Depends: debhelper (>= 9.0.0), cmake, ros-galactic-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-galactic-ruckig
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-galactic-ros-workspace
Description: Instantaneous Motion Generation for Robots and Machines.
